<template>
  <div :class="classes" class="flex flex-col items-stretch justify-start">
    <label
      v-if="name"
      class="text-xs pt-4 pb-2 text-grey-dark transition-long block"
      :class="{ focused: focused || value.length > 0 }"
    >
      {{ focused || value.length > 0 ? name : " " }}
    </label>
    <input
      @focusin="focused = true"
      @focusout="focused = false"
      v-bind:value="value"
      @input="$emit('input', $event.target.value)"
      @keyup.enter="$emit('enter', $event)"
      :type="type"
      :placeholder="
        focused || (value && value.length > 0) || !name ? placeholder : name
      "
      :class="iclass"
      class="bg-transparent border-b-2 border-grey-light block focus:border-black transition"
      :autofocus="autofocus"
      ref="inputRef"
    />
  </div>
</template>

<style scoped>
label:not(.focused) {
  color: #dae1e7;
}
</style>

<script lang=ts>
import { ref } from "vue";
export default {
  props: [
    "name",
    "type",
    "value",
    "placeholder",
    "classes",
    "iclass",
    "autofocus",
  ],
  emits: ["input", "enter"],
  data() {
    return {
      focused: false,
    };
  },
  setup(props) {
    const inputRef = ref<HTMLElement | null>(null);
    return {
      inputRef,
      focus() {
        inputRef.value?.focus();
      },
    };
  },
};
</script>
